<?php

require_once 'base/GepProdutosoliEntityBase.php';

/**
 * This class has been auto-generated by Setforms
 *
 * @package Entity
 * @author  Setforms
 */
class GepProdutosoliEntity extends GepProdutosoliEntityBase
{


    CONST IDATIVO = 'S';
    CONST SEM_PRODUTOS = 0;


    /**     ok
     * Retorna dados de uma determinada solicitacao.
     *
     * @param integer $nrorg         N?mero da Organizacao.
     * @param integer $nrsolicitacao N?mero da solicitacao.
     *
     * @throws Exception Quando nao houver produtos.
     *
     * @return Ambigous <mixed, NULL>|boolean
     */
    public static function retornaProdutoSoli($nrorg, $nrsolicitacao){
        $consulta = GepProdutosoli::consultaProdutoSoli($nrorg, $nrsolicitacao);
        if ($consulta instanceof GepProdutosoliEntity) {
            return $consulta;
        }

        throw new Exception('GepProdutosoliEntity: Nao ha produtos para esta solicitacao!', self::SEM_PRODUTOS);
    }


    /**      ok
     * Retorna a lista de produtos de uma determinada solicitacao.
     *
     * @param integer $nrorg         Numero da Organizacao.
     * @param integer $nrsolicitacao Numero da soliciacao.
     *
     * @throws Exception Caso nao tenha nenhum produto para a solicitacao.
     *
     * @return Ambigous <boolean, NULL, TkModelEntity>
     */
    public function consultaListaProdutoSoli($nrorg, $nrsolicitacao){
        $consulta = GepProdutosoli::consultaListaProdutoSoli($nrorg, $nrsolicitacao);

        if (count($consulta[0]) > 0) {
            return $consulta;
        }

        throw new Exception('GepProdutosoliEntity: Nao ha produtos para esta solicitacao!', self::SEM_PRODUTOS);
    }


    /**
     * Insere um novo produto com uma solicita??o determinada.
     *
     * @param integer $codigo      Novo c?digo.
     * @param integer $solicitacao N?mero da solicita??o.
     * @param integer $produto     C?digo do produto.
     * @param integer $operador    C?digo do Operador.
     * @param date    $data        Data da inser??o.
     * @param integer $nrorg       N?mero da Organiza??o.
     *
     * @return boolean
     */
    public function insereProdutoSoli(
        $codigo, $solicitacao, $produto, $operador, date $data, $nrorg
    ){
        try {
            $obj = new self();

            $obj->setNrprodutosoli($codigo);
            $obj->setNrsolicitacao($solicitacao);
            $obj->setCdproduto($produto);
            $obj->setCdoperinclusao($operador);
            $obj->setCdoperultatu($operador);
            $obj->setDtinclusao($data);
            $obj->setDtultatu($data);
            $obj->setIdativo(self::IDATIVO);
            $obj->setNrorg($nrorg);
            $obj->setNrorginclusao($nrorg);
            $obj->setNrorgultatu($nrorg);

            $obj->persist();

            return true;
        } catch (Exception $e) {
            showClassError($e, __FUNCTION__, __LINE__);
            return false;
        }
    }


    /**    ok
     * Gera novo codigo para o produto da solicitacao.
     *
     * @param integer $nrorg Numero da Organizacao.
     *
     * @return Ambigous <number, number>
     */
    public static function novoCodigoGepProdutoSoli($nrorg){
        $codigo = Novocodigo::geraCodigo($nrorg, 'GEP_PRODUTOSOLI', 10);
        return $codigo;
    }


    /**
     * Atualiza o produto de uma determinada solicita??o.
     *
     * @param integer $nrorg       N?mero da Organiza??o.
     * @param integer $solicitacao N?mero da solicita??o.
     * @param integer $nrproduto   C?digo do novo produto.
     * @param integer $operador    C?digo do operador de altera??o.
     * @param date    $data        Data da altera??o.
     *
     * @return boolean
     */
    public function atualizaProdutoSoli(
        $nrorg, $solicitacao, $nrproduto, $operador, date $data
    ){

        $lista_registro = GepProdutosoli::getObjectsByWhere(
            'NRORG = ? AND NRSOLICITACAO = ?',
            array(
             $nrorg,
             $solicitacao,
            )
        );

        foreach ($lista_registro as $produto) {
            $produto->setCdproduto($nrproduto);
            $produto->setNrorgultatu($nrorg);
            $produto->setCdoperultatu($operador);
            $produto->setDtultatu($data);
            $produto->persist();
        }

        return true;
    }


    /**
     * Exclui todos os produtos de uma determinada solicita??o.
     *
     * @param integer $solicitacao N?mero da Solicita??o.
     * @param integer $nrorg       N?mero da Organiza??o.
     *
     * @return boolean
     */
    public function excluiProdutoSoli($solicitacao, $nrorg){
        $exclusao = GepProdutosoli::excluiProdutoSoli($solicitacao, $nrorg);
        return $exclusao;
    }


}